#
#  Podium2LightUp v1.0
#  Copies any Podium 2 settings to LightUp format.
#
#  Created by Adam Billyard on 5/12/2012.
#  Copyright (c) 2012 Billyard Enterprises. All rights reserved.
#
 

if( not file_loaded?(__FILE__) )

	tools = UI.menu("Plugins")
	tools.add_separator
    tools.add_item("Import Podium 2 settings...") {
		
		# Materials
		mcount = 0
		Sketchup.active_model.materials.each {|m|

			pd = m.attribute_dictionary('podium_II')
			if pd
			
				m.set_attribute(:lmap, 'Kred', pd['diffuse']) if pd['diffuse']
				m.set_attribute(:lmap, 'Kgreen', pd['diffuse']) if pd['diffuse']
				m.set_attribute(:lmap, 'Kblue', pd['diffuse']) if pd['diffuse']

				m.set_attribute(:lmap, 'ior', pd['refraction']) if pd['refraction'] 
				m.set_attribute(:lmap, 'Ks', pd['reflection']) if pd['reflection']
				m.set_attribute(:lmap, 'Kb', pd['bump_depth']) if pd['bump_depth']

				if pd['light_power'] and (pd['light_power'] > 0.0)
					m.set_attribute(:lmap, 'power', 250.0 * pd['light_power'])
					m.set_attribute(:lmap, 'emitter', true) 
				end

				mcount += 1
			end
		}
		
		# LightSources
		lcount = 0
		Sketchup.active_model.definitions.each {|d|
			
			if d.name.include?("light-point")
			
				d.name = "PointLightSource" + d.name unless d.name.include?("PointLightSource")
				d.instances.each {|l|
				
					pd = l.attribute_dictionary('podium_II')
					if pd
						l.set_attribute(:lightsource, 'lumen', 250.0 * pd['light-power'])

						l.material = pd['light-color']
						
						lcount += 1
					end
				}
			end

			if d.name.include?("light-spot")
			
				d.name = "PointLightSource" + d.name unless d.name.include?("PointLightSource")
				d.instances.each {|l|
				
					pd = l.attribute_dictionary('podium_II')
					if pd
						l.set_attribute(:lightsource, 'lumen', 250.0 * pd['light-power'])

						l.material = pd['light-color']
						
						lcount += 1
					end
				}
			end
		}
		
		Sketchup.set_status_text "Converted #{mcount} materials, #{lcount} lights."
	}

	file_loaded(__FILE__)
end